//------------------------------------//
// Info button
//    taken from "HMDT Programming Dashboard" sample code
//------------------------------------//

var infoBody = null;
var infoButton = null;

function createInfoButton(body, div, color) {
  var backgroundUrl = "file:///System/Library/WidgetResources/ibutton/" + color + "_i.png";
  div.setAttribute("style", "opacity: 0.0; background: url(" + backgroundUrl + ") no-repeat top left;");
  
  body.addEventListener("mouseover", infoBodyMouseOver, true);
  body.addEventListener("mouseout", infoBodyMouseOut, true);
  
  infoBody = body;
  infoButton = div;
}

function infoBodyMouseOver(event) {
  infoButtonStartAnimationInDirection(1);
}

function infoBodyMouseOut(event) {
  infoButtonStartAnimationInDirection(0);
}

var infoAnimator = {
  
  fromValue: 0.0, 
  toValue: 1.0, 
  currentValue: 0.0, 
  
  duration: 500, 
  
  direction: 0, 
  startTime: 0, 
  frameRate: 13, 
  timer: null
};

function infoButtonStartAnimationInDirection(direction) {
  if (direction != infoAnimator.direction) {
    infoButtonStopAnimate();
    
    infoAnimator.startTime = (new Date).getTime() - infoAnimator.frameRate;
    infoAnimator.fromValue = infoAnimator.currentValue;
    direction == 0 ? infoAnimator.toValue = 0.0 : infoAnimator.toValue = 1.0;
    infoAnimator.direction = direction;
    
    infoAnimator.timer = setInterval("infoButtonStepNextFrame();", infoAnimator.frameRate);
  }
}

function infoButtonStopAnimate() {
  if (infoAnimator.timer) {
    clearInterval(infoAnimator.timer);
    infoAnimator.timer = null;
  }
}

function infoButtonStepNextFrame() {
  var elapsed = (new Date).getTime() - infoAnimator.startTime;
  if (elapsed < 0) elapsed = 0;
  if (elapsed > infoAnimator.duration) elapsed = infoAnimator.duration;
  
  if (elapsed >= infoAnimator.duration) {
    infoButtonStopAnimate();
    infoAnimator.currentValue = infoAnimator.toValue;
  }
  else {
    var scale = 0.5 - (0.5 * Math.cos(Math.PI * elapsed / infoAnimator.duration));
    infoAnimator.currentValue = infoButtonComputeNextFloat (infoAnimator.fromValue, infoAnimator.toValue, scale);
  }
  
  infoButton.style.opacity = infoAnimator.currentValue;
}

function infoButtonComputeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}

//------------------------------------//
// Info rollie button
//------------------------------------//

var infoRollieButton = null;

function createInfoRollieButton(div, color) {
  var backgroundUrl = "file:///System/Library/WidgetResources/ibutton/" + color + "_rollie.png";
  div.setAttribute("style", "opacity: 0.0; background: url(" + backgroundUrl + ") no-repeat top left;");
  
  div.addEventListener("mouseover", infoRollieButtonMouseOver, true);
  div.addEventListener("mouseout", infoRollieButtonMouseOut, true);
  
  infoRollieButton = div;
}

function infoRollieButtonMouseOver(event) {
  infoRollieButton.style.opacity = "0.15";
}

function infoRollieButtonMouseOut(event) {
  infoRollieButton.style.opacity = "0.0";
}
