var frontWidth;

var hisList = ["0","0","0","0","0","0","0","0","0","0"]
var numHisList = hisList.length;

var resHisList = ["0","0","0","0","0","0","0","0","0","0"]
var numResHisList = resHisList.length;

// FUNCTION awkalcExec
// main function to evaluate a formula
//--------------------------------
function awkalcExec(changeHis) {
	var inputText0 = document.getElementById("input").value;
	var inputText = inputText0;
	//convert degrees and radians
	if (document.getElementById("trigPopup").value == "deg") {
		inputText = inputText.replace(/asin\(/g,"asind(");
		inputText = inputText.replace(/acos\(/g,"acosd(");
		inputText = inputText.replace(/atan\(/g,"atand(");
		inputText = inputText.replace(/atan2\(/g,"atan2d(");
		inputText = inputText.replace(/sin\(/g,"sind(");
		inputText = inputText.replace(/cos\(/g,"cosd(");
		inputText = inputText.replace(/tan\(/g,"tand(");
	}
	//if multiple expressions separated by semicolons exist
	//the last one (lastExp) is evaluated
	semicolonPos = inputText.lastIndexOf(";");
	if (semicolonPos != -1) {
		lastExp = inputText.substr(semicolonPos+1,inputText.length-semicolonPos);
		inputText = inputText.substr(0,semicolonPos+1)
	} else {
		lastExp = inputText;
		inputText = "";
	}
	//define funcs & consts, and pass the formula to awk
	var resultString = //inputText+" : "+lastExp;
		widget.system("/usr/bin/awk '"+
			"function tan(arg) {return sin(arg)/cos(arg)} "+
			"function atan(arg) {return atan2(arg,1)} "+
			"function asin(arg) {if (arg==1) {return pi/2} else if (arg==-1) {return -pi/2} else {return atan(arg/sqrt(1-arg^2))}} "+
			"function acos(arg) {if (arg==0) {return pi/2} else if (arg>0) {return atan(sqrt(1-arg^2)/arg)} else {return pi+atan(sqrt(1-arg^2)/arg)}} "+
			"function log10(arg) {return log(arg)/log(10)} "+
			"function abs(arg) {if (arg<0) {return -arg} else {return arg}} "+
			"function sind(arg) {return sin(dtor*arg)} "+
			"function cosd(arg) {return cos(dtor*arg)} "+
			"function tand(arg) {return tan(dtor*arg)} "+
			"function asind(arg) {return rtod*asin(arg)} "+
			"function acosd(arg) {return rtod*acos(arg)} "+
			"function atand(arg) {return rtod*atan(arg)} "+
			"function atan2d(arg1,arg2) {return rtod*atan2(arg1,arg2)} "+
			"BEGIN{e=exp(1);pi=atan2(0,-1);dtor=pi/180;rtod=180/pi;"+
			inputText+'printf "%.10g",'+lastExp+"}'", null).outputString;
	document.getElementById("output").value = resultString;
	if (inputText0 != '') {
		hisList[numHisList-1] = inputText0;
		resHisList[numResHisList-1] = resultString;
		if (changeHis == 1) {
			updateHisList();
			updateResHisList();
		}
	}
}


// FUNCTION showBackside
// function to flip the widget: front->back
//--------------------------------
function showBackside(event) {
  frontWidth = window.outerWidth;
 
  if (frontWidth != 192) {
    var startRect = new AppleRect(0,0,frontWidth,window.innerHeight);
    var finishRect = new AppleRect(0,0,192,window.innerHeight);
    var currentRectAnimation = new AppleRectAnimation(startRect,finishRect,rectHandler);
    var currentAnimator = new AppleAnimator(500,13);

    currentAnimator.addAnimation(currentRectAnimation);
    currentAnimator.oncomplete = flipToBack;
    currentAnimator.start();
  } else {
    flipToBack();
  }
}

function flipToBack() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");

  if (window.widget) widget.prepareForTransition("ToBack");

	front.style.display = "none";
	back.style.display = "block";

	if (window.widget) {
		setTimeout("widget.performTransition();", 0);
	}

	// hide info button
	var infoRollie = document.getElementById("infoRollie");
	infoRollie.style.opacity = "0.0";
}

// FUNCTION showFrontside
// function to flip the widget: back->front
//--------------------------------
function showFrontside(event) {
	var front = document.getElementById("front");
	var back = document.getElementById("back");

  if (window.widget) widget.prepareForTransition("ToFront");

	front.style.display = "block";
	back.style.display = "none";

	if (window.widget) setTimeout("widget.performTransition();", 0);

  if (frontWidth != 192) setTimeout("flipToFront();",700);
}

function flipToFront() {
  var startRect = new AppleRect(0,0,192,window.innerHeight);
  var finishRect = new AppleRect(0,0,frontWidth,window.innerHeight);
  var currentRectAnimation = new AppleRectAnimation(startRect,finishRect,rectHandler);

  var currentAnimator = new AppleAnimator(500,13);
  currentAnimator.addAnimation(currentRectAnimation);
  currentAnimator.start();
}

// FUNCTION trigPopupChanged
// function called when trigPopup is changed
//--------------------------------
function trigPopupChanged() {
	var trig = document.getElementById("trigPopup");
	var trigUnit = trig.options[trig.selectedIndex].value;
	if (window.widget) widget.setPreferenceForKey(trigUnit,"trigKey");
	updateTrigLabel();
	awkalcExec(0);
}

// FUNCTION updateTrigLabel
// function to draw "deg" or "rad" onto trigPopup
//--------------------------------
function updateTrigLabel() {
	var trig = document.getElementById("trigPopup");
	var trigUnit = trig.options[trig.selectedIndex].value;
	document.getElementById("trigUnitLabel").innerText = trigUnit;
}

// FUNCTION hisPopupChanged
// function called when history popup is changed
//--------------------------------
function hisPopupChanged() {
	var value = document.getElementById("hisPopup").value;
	if (window.widget) {
		// update input field
		document.getElementById("input").value = value; //locationsList[j].name;
		awkalcExec(1);
	}
}

// FUNCTION resHisPopupChanged
// function called when result history popup is changed
//--------------------------------
function resHisPopupChanged() {
	var value = document.getElementById("resHisPopup").value;
	if (window.widget) {
		// update input field
		document.getElementById("output").value = value; //locationsList[j].name;
	}
}

// FUNCTION updateHisSelect
// function to update history popup menu
//--------------------------------
function updateHisSelect()
{
	var select = document.getElementById ("hisPopup");

	// remove all children
	while (select.hasChildNodes()) select.removeChild(select.firstChild);

	for (var i = 0; i < numHisList; ++i) {
		var element = document.createElement("option");
		element.innerText = hisList[i];
		select.appendChild (element);
	}
}

// FUNCTION updateHisList
// function to update history list
//--------------------------------
function updateHisList()
{
	var tmpStr = hisList[numHisList-1];
	for (var i=numHisList-2; i >=0; --i) {
		hisList[i+1] = hisList[i];
	}
	hisList[0] = tmpStr;
	updateHisSelect();
	
	// save history list to prefs
	if (window.widget) {
		for(i=0; i<numHisList; i++) {
			widget.setPreferenceForKey(hisList[i],"histKey"+i);
		}
	}
}

// FUNCTION updateResHisSelect
// function to update result history popup menu
//--------------------------------
function updateResHisSelect()
{
	var select = document.getElementById ("resHisPopup");

	// remove all children
	while (select.hasChildNodes()) select.removeChild(select.firstChild);

	for (var i = 0; i < numResHisList; ++i) {
		var element = document.createElement("option");
		element.innerText = resHisList[i];
		select.appendChild (element);
	}
}

// FUNCTION updateHisList
// function to update result history list
//--------------------------------
function updateResHisList()
{
	var tmpStr = resHisList[numResHisList-1];
	for (var i=numResHisList-2; i >=0; --i) {
		resHisList[i+1] = resHisList[i];
	}
	resHisList[0] = tmpStr;
	updateResHisSelect();
	
	// save history list to prefs
	if (window.widget) {
		for(i=0; i<numResHisList; i++) {
			widget.setPreferenceForKey(resHisList[i],"resHistKey"+i);
		}
	}
}

function rectHandler(rectAnimation,currentRect,startRect,finishRect) {
  window.resizeTo(currentRect.right,currentRect.bottom);
  widgetResized();
}
